
From: Bodo Stroesser <bstroesser@fijitsu-siemens.com>

If a signal handler is set to use the signal stack (SA_ONSTACK), but the
signal stack is disabled, the signal frame should be written to the current
stack without stack switching.

The reason for the bug is get_sigframe() using on_sig_stack() instead of
sas_ss_flags(), which would be ok.

Signed-off-by: Martin Schwidefsky <schwidefsky@de.ibm.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/s390/kernel/signal.c |    2 +-
 1 files changed, 1 insertion(+), 1 deletion(-)

diff -puN arch/s390/kernel/signal.c~s390-signal-stack-bug arch/s390/kernel/signal.c
--- 25/arch/s390/kernel/signal.c~s390-signal-stack-bug	Thu Mar 24 15:28:55 2005
+++ 25-akpm/arch/s390/kernel/signal.c	Thu Mar 24 15:28:55 2005
@@ -282,7 +282,7 @@ get_sigframe(struct k_sigaction *ka, str
 
 	/* This is the X/Open sanctioned signal stack switching.  */
 	if (ka->sa.sa_flags & SA_ONSTACK) {
-		if (! on_sig_stack(sp))
+		if (! sas_ss_flags(sp))
 			sp = current->sas_ss_sp + current->sas_ss_size;
 	}
 
_
